

      SUBROUTINE NTUP_INIT(ID,NAME)

!     row wise ntuple

      IMPLICIT NONE
      INTEGER ID
      CHARACTER*(*) NAME
      REAL FVALUE
      INTEGER IVALUE
      LOGICAL LVALUE

      INTEGER IDN /0/
      CHARACTER*80 TITLE
      INTEGER TIT_LEN
      integer NSIZ
      PARAMETER (NSIZ=512)
      INTEGER NVAR /0/
      REAL X(NSIZ)
      CHARACTER*8 VARLIST(NSIZ)
      SAVE IDN, TITLE, TIT_LEN, NVAR, X, VARLIST
      LOGICAL HEXIST, YES

      IDN=ID
      TITLE=NAME
      TIT_LEN=LEN(NAME)
      NVAR=0
      CALL VZERO(X,NSIZ)
      RETURN

      ENTRY NTUP_FFILL(NAME,FVALUE)

      IF(NVAR.GE.NSIZ) RETURN
      NVAR=NVAR+1
      VARLIST(NVAR)=NAME
      X(NVAR)=FVALUE
      RETURN

      ENTRY NTUP_IFILL(NAME,IVALUE)

      IF(NVAR.GE.NSIZ) RETURN
      NVAR=NVAR+1
      VARLIST(NVAR)=NAME
      X(NVAR)=IVALUE
      RETURN

      ENTRY NTUP_LFILL(NAME,LVALUE)

      IF(NVAR.GE.NSIZ) RETURN
      NVAR=NVAR+1
      VARLIST(NVAR)=NAME
      IF(LVALUE) THEN
         X(NVAR)=1.
      ELSE
         X(NVAR)=0.
      ENDIF
      RETURN

      ENTRY NTUP_FLUSH

      CALL IS_HBOOK_OPEN(YES)
      IF(.NOT.YES) RETURN
      IF(IDN.LE.0) RETURN
      IF(NVAR.LE.0) RETURN
      IF(.NOT.HEXIST(IDN)) THEN
         CALL HBOOKN(IDN,TITLE,NVAR,'//',4096,VARLIST)
         PRINT*,'ntuple: ',IDN,' ',TITLE(:TIT_LEN)
      ENDIF
      CALL HFN(IDN,X)
      NVAR=0
      RETURN
      END


